/* mapper7: create a zero-filled file using mmap */
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#ifndef MAP_FAILED
#define MAP_FAILED ((void *)-1)
#endif

int
main(int argc, char *argv[])
{
  int fd;
  caddr_t pa;
  int base, size, counter = 0;

  if (argc != 4) {
    printf("usage: %s file base size\n", argv[0]);
    exit(1);
  }
  base = atoi(argv[2]);
  size = atoi(argv[3]);
  printf("using base %d and size %d\n", base, size);

  fd = open(argv[1], O_RDWR|O_CREAT, 0777);
  if (fd < 0) {
    perror(argv[1]);
    exit(1);
  }
  printf("opened file %s\n", argv[1]);

  pa = mmap(0,
	    size,
	    PROT_READ|PROT_WRITE,
	    MAP_PRIVATE,
	    fd,
	    base);
  if (pa == MAP_FAILED) {
    perror("mmap");
    exit(1);
  }
  printf("file is mapped with address 0x%x\n", (int) pa);

  /* look for newlines bytes */
  pa[0] = 'x';
  printf("There were %d matches\n", counter);

  if (munmap(pa, size) < 0) {
    perror("munmap");
    exit(1);
  }
  printf("file is unmapped\n");

  close(fd);

  exit(0);
}
